From a3ef34f95bc18a8ec7c7c6d8768d002062345221 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 23 2021 02:11:58 +0000
Subject: [PATCH 2144/2232] Merge pull request #745 from dtolnay/pointers


Touch up PR 689
---

diff --git a/syntax/check.rs b/syntax/check.rs
index 052b248..0009eb1 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -1,15 +1,13 @@
 use crate::syntax::atom::Atom::{self, *};
 use crate::syntax::report::Errors;
 use crate::syntax::{
-    error, ident, trivial, Api, Array, Enum, ExternFn, ExternType, Impl, Lang, NamedType, Receiver,
-    Ref, Signature, SliceRef, Struct, Trait, Ty1, Type, TypeAlias, Types,
+    error, ident, trivial, Api, Array, Enum, ExternFn, ExternType, Impl, Lang, NamedType, Ptr,
+    Receiver, Ref, Signature, SliceRef, Struct, Trait, Ty1, Type, TypeAlias, Types,
 };
 use proc_macro2::{Delimiter, Group, Ident, TokenStream};
 use quote::{quote, ToTokens};
 use std::fmt::Display;
 
-use super::Ptr;
-
 pub(crate) struct Check<'a> {
     apis: &'a [Api],
     types: &'a Types<'a>,
@@ -236,7 +234,9 @@ fn check_type_ref(cx: &mut Check, ty: &Ref) {
 }
 
 fn check_type_ptr(cx: &mut Check, ty: &Ptr) {
-    if let Type::Ident(_) = ty.inner { return }
+    if let Type::Ident(_) = ty.inner {
+        return;
+    }
 
     cx.error(ty, "unsupported pointer type");
 }
diff --git a/syntax/impls.rs b/syntax/impls.rs
index 0cb20ff..8b0743b 100644
--- a/syntax/impls.rs
+++ b/syntax/impls.rs
@@ -1,12 +1,10 @@
 use crate::syntax::{
-    Array, ExternFn, Include, Lifetimes, Receiver, Ref, Signature, SliceRef, Ty1, Type, Var,
+    Array, ExternFn, Include, Lifetimes, Ptr, Receiver, Ref, Signature, SliceRef, Ty1, Type, Var,
 };
 use std::hash::{Hash, Hasher};
 use std::mem;
 use std::ops::{Deref, DerefMut};
 
-use super::Ptr;
-
 impl PartialEq for Include {
     fn eq(&self, other: &Self) -> bool {
         let Include {
diff --git a/syntax/parse.rs b/syntax/parse.rs
index 8f8075a..51b5e4b 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -5,24 +5,22 @@ use crate::syntax::report::Errors;
 use crate::syntax::Atom::*;
 use crate::syntax::{
     attrs, error, Api, Array, Derive, Doc, Enum, ExternFn, ExternType, ForeignName, Impl, Include,
-    IncludeKind, Lang, Lifetimes, NamedType, Namespace, Pair, Receiver, Ref, Signature, SliceRef,
-    Struct, Ty1, Type, TypeAlias, Var, Variant,
+    IncludeKind, Lang, Lifetimes, NamedType, Namespace, Pair, Ptr, Receiver, Ref, Signature,
+    SliceRef, Struct, Ty1, Type, TypeAlias, Var, Variant,
 };
 use proc_macro2::{Delimiter, Group, Span, TokenStream, TokenTree};
 use quote::{format_ident, quote, quote_spanned};
 use std::mem;
-use syn::{TypePtr, parse::{ParseStream, Parser}};
+use syn::parse::{ParseStream, Parser};
 use syn::punctuated::Punctuated;
 use syn::{
     Abi, Attribute, Error, Expr, Fields, FnArg, ForeignItem, ForeignItemFn, ForeignItemType,
     GenericArgument, GenericParam, Generics, Ident, ItemEnum, ItemImpl, ItemStruct, Lit, LitStr,
     Pat, PathArguments, Result, ReturnType, Signature as RustSignature, Token, TraitBound,
-    TraitBoundModifier, Type as RustType, TypeArray, TypeBareFn, TypeParamBound, TypePath,
+    TraitBoundModifier, Type as RustType, TypeArray, TypeBareFn, TypeParamBound, TypePath, TypePtr,
     TypeReference, Variant as RustVariant, Visibility,
 };
 
-use super::Ptr;
-
 pub mod kw {
     syn::custom_keyword!(Pin);
     syn::custom_keyword!(Result);
@@ -588,7 +586,10 @@ fn parse_extern_fn(
                     let name = pair(Namespace::default(), &ident, None, None);
                     if let Type::Ptr(_) = &ty {
                         if unsafety.is_none() {
-                            return Err(Error::new_spanned(arg, "pointer argument requires that the function be marked unsafe"));
+                            return Err(Error::new_spanned(
+                                arg,
+                                "pointer argument requires that the function be marked unsafe",
+                            ));
                         }
                     }
                     args.push_value(Var {
@@ -627,7 +628,6 @@ fn parse_extern_fn(
     let mut throws_tokens = None;
     let ret = parse_return_type(&foreign_fn.sig.output, &mut throws_tokens)?;
     let throws = throws_tokens.is_some();
-    let unsafety = foreign_fn.sig.unsafety;
     let fn_token = foreign_fn.sig.fn_token;
     let inherited_span = unsafety.map_or(fn_token.span, |unsafety| unsafety.span);
     let visibility = visibility_pub(&foreign_fn.vis, inherited_span);
@@ -1100,12 +1100,9 @@ fn parse_type_ptr(ty: &TypePtr) -> Result<Type> {
     let mutable = ty.mutability.is_some();
     let constness = ty.const_token;
     let mutability = ty.mutability;
-    if !constness.is_some() && !mutable {
-        return Err(Error::new_spanned(ty, "pointer is neither const nor mut"));
-    }
 
     let inner = parse_type(&ty.elem)?;
-    
+
     Ok(Type::Ptr(Box::new(Ptr {
         star,
         mutable,
diff --git a/syntax/tokens.rs b/syntax/tokens.rs
index d728ac0..13b5cd3 100644
--- a/syntax/tokens.rs
+++ b/syntax/tokens.rs
@@ -1,14 +1,12 @@
 use crate::syntax::atom::Atom::*;
 use crate::syntax::{
-    Array, Atom, Derive, Enum, ExternFn, ExternType, Impl, Lifetimes, NamedType, Receiver, Ref,
-    Signature, SliceRef, Struct, Ty1, Type, TypeAlias, Var,
+    Array, Atom, Derive, Enum, ExternFn, ExternType, Impl, Lifetimes, NamedType, Ptr, Receiver,
+    Ref, Signature, SliceRef, Struct, Ty1, Type, TypeAlias, Var,
 };
 use proc_macro2::{Ident, Span, TokenStream};
 use quote::{quote_spanned, ToTokens};
 use syn::{token, Token};
 
-use super::Ptr;
-
 impl ToTokens for Type {
     fn to_tokens(&self, tokens: &mut TokenStream) {
         match self {
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 5f11a6a..fcbe153 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -2,6 +2,7 @@
     clippy::boxed_local,
     clippy::just_underscores_and_digits,
     clippy::let_underscore_drop,
+    clippy::missing_safety_doc,
     clippy::must_use_candidate,
     clippy::needless_lifetimes,
     clippy::needless_pass_by_value,
@@ -121,8 +122,8 @@ pub mod ffi {
         fn c_return_nested_ns_ref(shared: &ABShared) -> &usize;
         fn c_return_ns_enum(n: u16) -> AEnum;
         fn c_return_nested_ns_enum(n: u16) -> ABEnum;
-        fn c_return_opaque_raw_ptr(n: usize) -> *const C;
-        fn c_return_opaque_mut_raw_ptr(n: usize) -> *mut C;
+        fn c_return_const_ptr(n: usize) -> *const C;
+        fn c_return_mut_ptr(n: usize) -> *mut C;
 
         fn c_take_primitive(n: usize);
         fn c_take_shared(shared: Shared);
@@ -163,12 +164,8 @@ pub mod ffi {
         fn c_take_nested_ns_shared(shared: ABShared);
         fn c_take_rust_vec_ns_shared(v: Vec<AShared>);
         fn c_take_rust_vec_nested_ns_shared(v: Vec<ABShared>);
-        /// # Unsafety
-        /// To keep clippy happy.
-        unsafe fn c_take_opaque_mut_raw_ptr(c: *mut C) -> usize;
-        /// # Unsafety
-        /// To keep clippy happy.
-        unsafe fn c_take_opaque_raw_ptr(c: *const C) -> usize;
+        unsafe fn c_take_const_ptr(c: *const C) -> usize;
+        unsafe fn c_take_mut_ptr(c: *mut C) -> usize;
 
         fn c_try_return_void() -> Result<()>;
         fn c_try_return_primitive() -> Result<usize>;
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 5cd1511..831097d 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -207,23 +207,9 @@ Enum c_return_enum(uint16_t n) {
   }
 }
 
-const C* c_return_opaque_raw_ptr(size_t c) {
-  return new C(c);
-}
-
-C* c_return_opaque_mut_raw_ptr(size_t c) {
-  return new C(c);
-}
+const C *c_return_const_ptr(size_t c) { return new C(c); }
 
-size_t c_take_opaque_raw_ptr(const C* c) {
-  return c->get();
-}
-
-size_t c_take_opaque_mut_raw_ptr(C* c) {
-  size_t result = c->get();
-  delete c;
-  return result;
-}
+C *c_return_mut_ptr(size_t c) { return new C(c); }
 
 Borrow::Borrow(const std::string &s) : s(s) {}
 
@@ -526,6 +512,14 @@ void c_take_nested_ns_enum(::A::B::ABEnum e) {
   }
 }
 
+size_t c_take_const_ptr(const C *c) { return c->get(); }
+
+size_t c_take_mut_ptr(C *c) {
+  size_t result = c->get();
+  delete c;
+  return result;
+}
+
 void c_try_return_void() {}
 
 size_t c_try_return_primitive() { return 2020; }
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index 3de24e6..eaa4361 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -118,8 +118,8 @@ Enum c_return_enum(uint16_t n);
 ::A::AEnum c_return_ns_enum(uint16_t n);
 ::A::B::ABEnum c_return_nested_ns_enum(uint16_t n);
 std::unique_ptr<Borrow> c_return_borrow(const std::string &s);
-const C* c_return_opaque_raw_ptr(size_t n);
-C* c_return_opaque_mut_raw_ptr(size_t n);
+const C *c_return_const_ptr(size_t n);
+C *c_return_mut_ptr(size_t n);
 
 void c_take_primitive(size_t n);
 void c_take_shared(Shared shared);
@@ -163,8 +163,8 @@ void c_take_callback(rust::Fn<size_t(rust::String)> callback);
 void c_take_enum(Enum e);
 void c_take_ns_enum(::A::AEnum e);
 void c_take_nested_ns_enum(::A::B::ABEnum e);
-size_t c_take_opaque_raw_ptr(const C* c);
-size_t c_take_opaque_mut_raw_ptr(C* c);
+size_t c_take_const_ptr(const C *c);
+size_t c_take_mut_ptr(C *c);
 
 void c_try_return_void();
 size_t c_try_return_primitive();
diff --git a/tests/test.rs b/tests/test.rs
index 2c7f763..32b8e83 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -338,16 +338,16 @@ fn test_extern_opaque() {
 
 #[test]
 fn test_raw_ptr() {
-    let c = ffi::c_return_opaque_mut_raw_ptr(2023);
+    let c = ffi::c_return_mut_ptr(2023);
     let mut c_unique = unsafe { cxx::UniquePtr::from_raw(c) };
     assert_eq!(2023, c_unique.pin_mut().set_succeed(2023).unwrap());
     // c will be dropped as it's now in a UniquePtr
 
-    let c2 = ffi::c_return_opaque_mut_raw_ptr(2024);
-    assert_eq!(2024, unsafe { ffi::c_take_opaque_raw_ptr(c2) });
-    assert_eq!(2024, unsafe { ffi::c_take_opaque_mut_raw_ptr(c2) }); // deletes c2
+    let c2 = ffi::c_return_mut_ptr(2024);
+    assert_eq!(2024, unsafe { ffi::c_take_const_ptr(c2) });
+    assert_eq!(2024, unsafe { ffi::c_take_mut_ptr(c2) }); // deletes c2
 
-    let c3 = ffi::c_return_opaque_raw_ptr(2025);
-    assert_eq!(2025, unsafe { ffi::c_take_opaque_raw_ptr(c3) });
-    assert_eq!(2025, unsafe { ffi::c_take_opaque_mut_raw_ptr(c3 as *mut ffi::C) }); // deletes c3
-}
\ No newline at end of file
+    let c3 = ffi::c_return_const_ptr(2025);
+    assert_eq!(2025, unsafe { ffi::c_take_const_ptr(c3) });
+    assert_eq!(2025, unsafe { ffi::c_take_mut_ptr(c3 as *mut ffi::C) }); // deletes c3
+}
diff --git a/tests/ui/ptr_missing_unsafe.rs b/tests/ui/ptr_missing_unsafe.rs
new file mode 100644
index 0000000..56f0007
--- /dev/null
+++ b/tests/ui/ptr_missing_unsafe.rs
@@ -0,0 +1,10 @@
+#[cxx::bridge]
+mod ffi {
+    unsafe extern "C++" {
+        type C;
+
+        fn not_unsafe_ptr(c: *mut C);
+    }
+}
+
+fn main() {}
diff --git a/tests/ui/ptr_missing_unsafe.stderr b/tests/ui/ptr_missing_unsafe.stderr
new file mode 100644
index 0000000..65f53a9
--- /dev/null
+++ b/tests/ui/ptr_missing_unsafe.stderr
@@ -0,0 +1,5 @@
+error: pointer argument requires that the function be marked unsafe
+ --> $DIR/ptr_missing_unsafe.rs:6:27
+  |
+6 |         fn not_unsafe_ptr(c: *mut C);
+  |                           ^^^^^^^^^
diff --git a/tests/ui/ptr_no_const_mut.rs b/tests/ui/ptr_no_const_mut.rs
new file mode 100644
index 0000000..eecec3f
--- /dev/null
+++ b/tests/ui/ptr_no_const_mut.rs
@@ -0,0 +1,10 @@
+#[cxx::bridge]
+mod ffi {
+    unsafe extern "C++" {
+        type C;
+
+        fn get_neither_const_nor_mut() -> *C;
+    }
+}
+
+fn main() {}
diff --git a/tests/ui/ptr_no_const_mut.stderr b/tests/ui/ptr_no_const_mut.stderr
new file mode 100644
index 0000000..8a39185
--- /dev/null
+++ b/tests/ui/ptr_no_const_mut.stderr
@@ -0,0 +1,13 @@
+error: expected mut or const in raw pointer type
+ --> $DIR/ptr_no_const_mut.rs:6:43
+  |
+6 |         fn get_neither_const_nor_mut() -> *C;
+  |                                           ^ expected mut or const in raw pointer type
+  |
+  = help: use `*mut T` or `*const T` as appropriate
+
+error: expected `const` or `mut`
+ --> $DIR/ptr_no_const_mut.rs:6:44
+  |
+6 |         fn get_neither_const_nor_mut() -> *C;
+  |                                            ^
diff --git a/tests/ui/ptr_unsupported.rs b/tests/ui/ptr_unsupported.rs
new file mode 100644
index 0000000..ca1580a
--- /dev/null
+++ b/tests/ui/ptr_unsupported.rs
@@ -0,0 +1,14 @@
+#[cxx::bridge]
+mod ffi {
+    unsafe extern "C++" {
+        type C;
+
+        fn get_ptr_to_ptr() -> *mut *mut C;
+        fn get_ptr_to_reference() -> *mut &C;
+        fn get_reference_to_ptr() -> &*mut C;
+        fn get_uniqueptr_to_ptr() -> UniquePtr<*mut C>;
+        fn get_vector_of_ptr() -> UniquePtr<CxxVector<*mut C>>;
+    }
+}
+
+fn main() {}
diff --git a/tests/ui/ptr_unsupported.stderr b/tests/ui/ptr_unsupported.stderr
new file mode 100644
index 0000000..b5e8a78
--- /dev/null
+++ b/tests/ui/ptr_unsupported.stderr
@@ -0,0 +1,29 @@
+error: unsupported pointer type
+ --> $DIR/ptr_unsupported.rs:6:32
+  |
+6 |         fn get_ptr_to_ptr() -> *mut *mut C;
+  |                                ^^^^^^^^^^^
+
+error: unsupported pointer type
+ --> $DIR/ptr_unsupported.rs:7:38
+  |
+7 |         fn get_ptr_to_reference() -> *mut &C;
+  |                                      ^^^^^^^
+
+error: unsupported reference type
+ --> $DIR/ptr_unsupported.rs:8:38
+  |
+8 |         fn get_reference_to_ptr() -> &*mut C;
+  |                                      ^^^^^^^
+
+error: unsupported unique_ptr target type
+ --> $DIR/ptr_unsupported.rs:9:38
+  |
+9 |         fn get_uniqueptr_to_ptr() -> UniquePtr<*mut C>;
+  |                                      ^^^^^^^^^^^^^^^^^
+
+error: unsupported vector target type
+  --> $DIR/ptr_unsupported.rs:10:45
+   |
+10 |         fn get_vector_of_ptr() -> UniquePtr<CxxVector<*mut C>>;
+   |                                             ^^^^^^^^^^^^^^^^^^
